#!/bin/sh
set +e

update-ca-certificates
update-resolv

waitForService()
{
    ./wait-for-it.sh $1 -t 2 1>/dev/null 2>&1
    status=$?
    while [ $status != 0 ]
    do
        echo "[x] wating for $1..."
        sleep 1
        ./wait-for-it.sh $1 -t 2 1>/dev/null 2>&1
        status=$?
    done
}

waitForService "api-registry:8501"
# waitForService "api-registry:${API_REGISTRY_UI_PORT}"

set -e

# first arg is `-f` or `--some-option`
if [ "${1#-}" != "$1" ]; then
    set -- traefik "$@"
fi

# if our command is a valid Traefik subcommand, let's invoke it through Traefik instead
# (this allows for "docker run traefik version", etc)
if traefik "$1" --help >/dev/null 2>&1
then
    set -- traefik "$@"
else
    echo "= '$1' is not a Traefik command: assuming shell execution." 1>&2
fi

register-service

exec "$@"
